#include "shellbuffer.h"
#include "scene/meshnode.h"
#include "scene/textnode.h"
#include "sparrowshell/sparrowshell.h"
#include "tools/utils.h"
#include <iostream>

void ShellBuffer::toggleBuffer(){
    for(auto child : m_children)
        child->toggleVisibility();
}

void ShellBuffer::update()
{
    TextNode* tnode;
    glm::vec2 text_pos(0);

//    std::cout << m_children.size() << std::endl;

//    if (m_parent){
//        SparrowShell* shell = dynamic_cast<SparrowShell*>(m_parent);
//        if(shell && shell->isEnabled())
//        {
//            for(unsigned int i = 0; i< size();i++)
//            {
//                tnode = (TextNode*) (*this)[i];
  //              std::cout << tnode->getString() << std::endl;
   //             if (i >= m_index && i < m_index+SparrowShell::BUFFER_DISPLAYED_NUMBER)
   //             {
    //                tnode->moveTo(glm::vec3(text_pos,0));
    //                text_pos.y += m_font_size;
//                }
//                else
//                    tnode->moveTo(glm::vec3(-100,-100,0));
//            }
//        }
//    }
}

void ShellBuffer::push(TextNode* s){
    if (m_children.size() >= m_max_size){
        m_children[m_zero_offset++] = s;
        m_zero_offset %= m_max_size;
    }else
        m_children.push_back(s);
}
